<?php
//////////////////////////////////////////////////////////////////////////////////
//    					 copyright (c) Arfooo Annuaire                          //
//   				 by Hocine Guillaume (c) 2007 - 2008                        //
//       					http://www.arfooo.com/                              //
//    Licence Creative Commons http://creativecommons.org/licenses/by/2.0/fr/   //
//////////////////////////////////////////////////////////////////////////////////

function createDbTables($tablesPrefix, $siteRootUrl)
{

    $directoryOpeningDate = date("Y-m-d");

    $createTablesSql = "

CREATE TABLE `adcriterias` (
  `adCriterionId` mediumint(8) unsigned NOT NULL auto_increment,
  `name` text NOT NULL,
  `htmlContent` text NOT NULL,
  PRIMARY KEY  (`adCriterionId`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;


CREATE TABLE `ads` (
  `adId` mediumint(8) unsigned NOT NULL auto_increment,
  `adCriterionId` mediumint(8) unsigned NOT NULL,
  `page` varchar(64) NOT NULL,
  `place` varchar(64) NOT NULL,
  PRIMARY KEY  (`adId`),
  KEY `AdCriterionID` (`adCriterionId`),
  KEY `Page` (`page`,`place`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;


CREATE TABLE `bannedemails` (
  `banId` mediumint(8) NOT NULL auto_increment,
  `email` varchar(64) NOT NULL,
  `dateBanned` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  PRIMARY KEY  (`banId`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;


CREATE TABLE `bannedips` (
  `banId` mediumint(8) NOT NULL auto_increment,
  `remoteIp` varchar(15) NOT NULL,
  `dateBanned` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  PRIMARY KEY  (`banId`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;


CREATE TABLE `bannedsites` (
  `banId` mediumint(8) NOT NULL auto_increment,
  `site` varchar(255) NOT NULL,
  `dateBanned` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  PRIMARY KEY  (`banId`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;


CREATE TABLE `cachegoogledetails` (
  `cachePageRankID` mediumint(8) unsigned NOT NULL auto_increment,
  `url` varchar(64) NOT NULL,
  `pageRank` tinyint(2) unsigned NOT NULL,
  `backlinksCount` int(11) unsigned NOT NULL,
  `indexedPagesCount` int(11) unsigned NOT NULL,
  `generationDate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  PRIMARY KEY  (`cachePageRankID`),
  KEY `URL` (`url`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;


CREATE TABLE `captchacodes` (
  `publicCode` varchar(32) NOT NULL,
  `privateCode` varchar(4) NOT NULL,
  `generationDate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  PRIMARY KEY  (`publicCode`),
  KEY `GenerationDate` (`generationDate`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


CREATE TABLE `categories` (
  `categoryId` mediumint(8) unsigned NOT NULL auto_increment,
  `parentCategoryId` mediumint(8) NOT NULL,
  `name` varchar(64) NOT NULL,
  `title` varchar(255) NOT NULL,
  `description` text NOT NULL,
  `imageSrc` varchar(255) default NULL,
  `possibleTender` enum('0','1') NOT NULL,
  `validatedSitesCount` mediumint(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (`categoryId`),
  KEY `Name` (`name`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;


CREATE TABLE `categoryparents` (
  `parentId` mediumint(8) unsigned NOT NULL,
  `categoryId` mediumint(8) unsigned NOT NULL,
  `depth` tinyint(2) unsigned NOT NULL,
  KEY `ParentID` (`parentId`),
  KEY `CategoryID` (`categoryId`),
  KEY `Depth` (`depth`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


CREATE TABLE `comments` (
  `commentId` mediumint(8) unsigned NOT NULL auto_increment,
  `remoteIp` varchar(15) NOT NULL,
  `siteId` mediumint(8) unsigned NOT NULL,
  `text` text NOT NULL,
  `date` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `pseudo` varchar(255) NOT NULL,
  `validated` enum('0','1') NOT NULL default '0',
  PRIMARY KEY  (`commentId`),
  KEY `SiteID` (`siteId`,`remoteIp`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;


CREATE TABLE `custommessages` (
  `messageId` varchar(20) NOT NULL,
  `title` text NOT NULL,
  `description` text NOT NULL,
  `userText` text NOT NULL,
  `userDefined` enum('0','1') NOT NULL default '1',
  `type` enum('email','custom') NOT NULL default 'email',
  PRIMARY KEY  (`messageId`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


CREATE TABLE `hits` (
  `hitId` mediumint(8) unsigned NOT NULL auto_increment,
  `remoteIp` char(15) NOT NULL,
  `siteId` mediumint(8) unsigned NOT NULL,
  `date` timestamp NOT NULL default CURRENT_TIMESTAMP,
  PRIMARY KEY  (`hitId`),
  KEY `SiteID` (`siteId`,`remoteIp`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;


CREATE TABLE `keywords` (
  `keywordId` mediumint(8) unsigned NOT NULL auto_increment,
  `keyword` varchar(64) NOT NULL,
  PRIMARY KEY  (`keywordId`),
  KEY `Keyword` (`keyword`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;


CREATE TABLE `keywordsofsites` (
  `keywordId` mediumint(8) unsigned NOT NULL,
  `siteId` mediumint(8) unsigned NOT NULL,
  KEY `SiteID` (`siteId`),
  KEY `KeywordID` (`keywordId`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


CREATE TABLE `otherreferrersites` (
  `referrerSiteId` mediumint(8) unsigned NOT NULL auto_increment,
  `url` varchar(255) NOT NULL,
  `referrerTimes` mediumint(8) NOT NULL,
  PRIMARY KEY  (`referrerSiteId`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;


CREATE TABLE `refusals` (
  `moderatorId` mediumint(8) unsigned NOT NULL,
  `refusedSitesCount` mediumint(8) unsigned NOT NULL default '0',
  KEY `moderatorId` (`moderatorId`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


CREATE TABLE `settings` (
  `key` varchar(64) NOT NULL,
  `value` text NOT NULL,
  PRIMARY KEY  (`key`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


CREATE TABLE `sites` (
  `siteId` mediumint(8) unsigned NOT NULL auto_increment,
  `siteTitle` varchar(255) NOT NULL,
  `url` varchar(255) NOT NULL,
  `description` text NOT NULL,
  `visitsCount` int(11) NOT NULL default '0',
  `votesAverage` float(10,1) NOT NULL default '0.0',
  `creationDate` timestamp NOT NULL default CURRENT_TIMESTAMP,
  `imageSrc` varchar(100) default NULL,
  `problemExists` smallint(6) NOT NULL default '0',
  `webmasterId` mediumint(8) NOT NULL default '0',
  `status` enum('waiting','validated','banned') NOT NULL,
  `categoryId` mediumint(8) NOT NULL,
  `referrerTimes` int(11) NOT NULL default '0',
  `proposalForKeywords` text,
  `proposalForCategory` text,
  `rssTitle` text NOT NULL,
  `returnBond` text NOT NULL,
  `priority` tinyint(2) unsigned NOT NULL default '0',
  `webmasterEmail` text,
  `webmasterName` text,
  `moderatorId` mediumint(8) NOT NULL default '0',
  `rssFeedOfSite` text NOT NULL,
  `votesCount` mediumint(8) unsigned NOT NULL default '0',
  `commentsCount` mediumint(8) NOT NULL default '0',
  `name` text,
  `httpCode` mediumint(3) unsigned default NULL,
  `backlinkExists` enum('0','1') default NULL,
  `countryCode` char(2) default NULL,
  `address` varchar(255) default NULL,
  `zipCode` varchar(255) default NULL,
  `city` varchar(255) default NULL,
  `country` varchar(255) default NULL,
  `phoneNumber` varchar(255) default NULL,
  `faxNumber` varchar(255) default NULL,
  PRIMARY KEY  (`siteId`),
  KEY `WebmasterID` (`webmasterId`),
  KEY `CategoryID` (`categoryId`),
  KEY `Status` (`status`),
  KEY `URL` (`url`),
  KEY `visitsCount` (`visitsCount`),
  FULLTEXT KEY `SiteTitle` (`siteTitle`),
  FULLTEXT KEY `Description` (`description`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;


CREATE TABLE `tasks` (
  `taskId` varchar(32) NOT NULL,
  `status` enum('init','active','pause','stop','finish') NOT NULL default 'active',
  `livePingTime` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `parsedItems` mediumint(8) NOT NULL default '0',
  `totalItems` mediumint(8) NOT NULL default '0',
  `data` text NOT NULL,
  PRIMARY KEY  (`taskId`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


CREATE TABLE `users` (
  `userId` mediumint(8) unsigned NOT NULL auto_increment,
  `login` varchar(64) NOT NULL default '',
  `password` varchar(64) NOT NULL,
  `email` varchar(64) NOT NULL,
  `role` varchar(32) NOT NULL,
  PRIMARY KEY  (`userId`),
  UNIQUE KEY `Email` (`email`),
  KEY `Role` (`role`),
  KEY `Username` (`login`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;


CREATE TABLE `visits` (
  `ip` char(15) NOT NULL,
  `type` enum('ref','vis') NOT NULL,
  `id` int(11) default NULL,
  `ts` timestamp NOT NULL default CURRENT_TIMESTAMP,
  KEY `ts` (`ts`),
  KEY `ip` (`ip`,`id`,`type`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


CREATE TABLE `votes` (
  `voteId` mediumint(8) unsigned NOT NULL auto_increment,
  `remoteIp` varchar(15) NOT NULL,
  `siteId` mediumint(8) NOT NULL,
  `value` tinyint(1) NOT NULL,
  `date` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  PRIMARY KEY  (`voteId`),
  KEY `RemoteIP` (`remoteIp`),
  KEY `SiteID` (`siteId`,`value`),
  KEY `Date` (`date`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;
";

$dataSql = "
INSERT INTO `custommessages` (`messageId`, `title`, `description`, `userText`, `userDefined`, `type`) VALUES
('validateSite', 'Your site is accepted', 'Your site [site name] is accepted in the category [name of the category] \r\nYou can see your site at this address [url site details] \r\n\r\nThank you for your site listed in the directory [name of directory] [url of your directory]\r\n\r\n', 'When you validate a site', '0', 'email'),
('refuseSite', 'Your site is refused ', 'Your site [site name] is denied in the category [name of the category]. \r\nIt does not correspond to the criteria for listing in our directory [name of directory] [url of your directory]\r\n\r\nAfter modifying your site, do not hesitate to come to resubmit \r\nIn our directory [name of directory] [url of your directory]\r\n', 'For mail received by the webmaster if the site is refused', '0', 'email'),
('submitSite', 'A new website has just been submitted ', 'Information to the new site: \r\nName: [site name] \r\nURL: [url site] \r\nDescription: [description of the site] \r\nCategory: [name of the category]\r\n\r\n', 'Received by administrator the directory when a site is submitted', '0', 'email'),
('directoryDescription', 'Title description 1 for a better ranking in search engines if you want', 'description 1 for a better ranking in search engines if you want.', '', '0', 'custom'),
('directoryCondition', '', 'Regulation and condition of submission of websites. <br />\r\n<br />\r\n<br />\r\ndddd\r\n<br />\r\n<br />', '', '0', 'custom'),
('webmasterSubmitSite', 'Your site has been successfully submitted ', 'Information on your site: \r\nName: [site name] \r\nURL: [url site] \r\nDescription: [description of the site]\r\nYour site has been submitted in the category [name of the category] \r\n\r\nThank you for submitting your site in our directory [name of directory] [url of your directory]\r\n', 'Email received by the webmaster when he submitt a site', '0', 'email');


INSERT INTO `refusals` (`moderatorId`, `refusedSitesCount`) VALUES
(0, 0);

INSERT INTO `settings` (`key`, `value`) VALUES ('selectionPeriod', '1'),
('selectionSitesCount', '4'),
('selectionSiteIds', ''),
('selectionGenerationDate', ''),
('siteNoveltyPeriod', '30'),
('maxTopNotesCount', '20'),
('maxTopHitsCount', '20'),
('maxTopRankCount', '20'),
('maxTopReferrersCount', '20'),
('topReferrersLastResetDate', ''),
('sitesPerPageInCategory', '20'),
('sitesPerPageInKeywords', '20'),
('sitesPerPageInSearch', '20'),
('commentsEnabled', '1'),
('urlRewriting', '1'),
('notationsEnabled', '1'),
('hitsEnabled', '1'),
('topRankEnabled', '1'),
('topReferrersEnabled', '1'),
('categoriesImages', '1'),
('sitesImages', '1'),
('rssNewsEnabled', '1'),
('rssCategoriesEnabled', '1'),
('siteTitle', 'Arfooo directory title'),
('language', 'en'),
('countOfSubcategoriesUnderCategory', '2'),
('maxCategoriesCountPerSite', '1'),
('maxKeywordsCountPerSite', '5'),
('categoriesInLeftMenuEnabled', '1'),
('keywordsEnabled', '1'),
('cacheSiteImagesEnabled', '1'),
('deletionPeriodOfTopReferrers', '30'),
('registrationOfWebmastersEnabled', '1'),
('inscriptionsOfSitesEnabled', '1'),
('automaticSiteValidation', '0'),
('inscriptionCheckHttpResponseCode', '0'),
('sendEmailsOnInscriptionAndApproval', '1'),
('siteDescriptionMaxLength', '400'),
('metaTagScannerEnabled', '1'),
('informWebmastersForAdminDecisions', '1'),
('showingPagerankEnabled', '1'),
('showingBacklinksCountEnabled', '1'),
('showingIndexedPagesCountEnabled', '1'),
('wayForPagerankExtraction', '1'),
('pageRankCachingEnabled', '1'),
('pageRankCacheExpiration', '90'),
('statisticsEnabled', '1'),
('displayValidatedSitesCount', '1'),
('displayWaitingSitesCount', '1'),
('displayRefusedSitesCount', '1'),
('displayAllCategoriesCount', '1'),
('displayKeywordsCount', '1'),
('displayWebmastersCount', '1'),
('captchaEnabledOnWebmasterRegistration', '1'),
('captchaEnabledOnSiteInscription', '1'),
('captchaEnabledOnComments', '1'),
('captchaEnabledOnContactForm', '1'),
('additionalServerUrl', ''),
('siteRootUrl', '$siteRootUrl'),
('siteDescription', 'Arfooo directory description'),
('thumbsGeneratorUrl', ''),
('templateName', 'arfooo'),
('directoryOpeningDate', '$directoryOpeningDate'),
('dateFormat', 'd-m-Y'),
('automaticCommentValidation', '1'),
('backLinkMandatory', '0'),
('showRandomSitesInDetails', '1'),
('randomSitesInDetailsCount', '5'),
('randomSitesInDetailsDescriptionLength', '100'),
('minSiteDescriptionLength', '100'),
('rssSitesEnabled', '1'),
('countryFlagsEnabled', '1'),
('similarSiteKeywordMatch', '0'),
('googleMapKey', ''),
('googleMapEnabled', '0'),
('googleMapZoom', '3'),
('remoteRssParsingEnabled', '1'),
('companyInfoEnabled', '0'),
('sitesSortyBy', 'creationDate'),
('numberOfItemsForRssParsing', '5'),
('numberOfCharactersForRssParsing', '150'),
('numberOfCharactersForItemDescription', '200'),
('magpieRssCacheMaxAgeDays', '1');

";

     $tableStats = array();

     foreach(explode(";", $createTablesSql) as $sql)
     {
        $sql = trim($sql);
        if(empty($sql))continue;
        preg_match("#CREATE TABLE `(.*?)`#", $sql, $match);
        $tableName = $match[1];

        if(executeQueryWithPrefix($sql, $tablesPrefix))
        {
            $message = "";
            $created = true;
        }
        else
        {
            $message = mysql_error();
            $created = false;
        }

        $tableStats[$tableName]['message'] = $message;
        $tableStats[$tableName]['created'] = $created;
    }

    foreach(explode(";", $dataSql) as $sql)
    {
        executeQueryWithPrefix($sql, $tablesPrefix);
    }

    return $tableStats;

}

?>
